Summary: Header files for the Linux kernel for use by glibc
Name: glibc-kernheaders
Version: 3.0
Release: 5.2
License: GPL
Group: Development/System
ExclusiveOS: Linux
Obsoletes: kernel-headers
Provides: kernel-headers = 2.4.2
Prereq: fileutils initscripts >= 5.83
%undefine _enable_debug_packages

BuildRoot: %{_tmppath}/glibc-kernheaders-root

%ifarch i386 i586 i686 athlon
%define _arch i386
%endif

Source0: glibc-kernheaders.tar.bz2
Patch0: glibc-kernheaders-2.4-atmfix.patch
Patch1: glibc-kernheaders-2.4-mtd.patch
Patch2: glibc-kernheaders-2.4-audit.patch
Patch3: glibc-kernheaders-2.4-ppc64-ptrace-1.patch
Patch4: glibc-kernheaders-2.4-ppc-ptrace-2.patch
Patch5: glibc-kernheaders-2.4-ia64-ptrace.patch
Patch6: glibc-kernheaders-2.4-v6only.patch
#Patch7: glibc-kernheaders-2.4-kversion.patch
Patch8: glibc-kernheaders-2.4-videodev.patch
Patch9: glibc-kernheaders-2.4-quota.patch
Patch10: glibc-kernheaders-2.4-socket.patch
Patch11: glibc-kernheaders-2.4-x86_64-mce.patch
Patch12: glibc-kernheaders-2.4-futex.patch
Patch13: glibc-kernheaders-2.4-gplpedantry.patch
Patch14: glibc-kernheaders-2.4-x86_64-epoll.patch
Patch15: glibc-kernheaders-2.4-uinput.patch
Patch16: glibc-kernheaders-2.4-ppc64-stat.patch
Patch17: glibc-kernheaders-2.4-ppc64-statfs.patch
Patch18: glibc-kernheaders-2.4-infiniband.patch
Patch19: glibc-kernheaders-2.4-miitypes.patch
Patch20: glibc-kernheaders-2.4-shmexec.patch
Patch21: glibc-kernheaders-2.4-dvb.patch
Patch22: glibc-kernheaders-2.4-keyctl.patch
Patch23: glibc-kernheaders-2.4-unistd.patch
Patch24: glibc-kernheaders-2.4-watchdog.patch
Patch25: glibc-kernheaders-2.4-iphdr.patch
Patch26: glibc-kernheaders-2.4-errno.patch

%description
Kernel-headers includes the C header files that specify the interface
between the Linux kernel and userspace libraries and programs.  The
header files define structures and constants that are needed for
building most standard programs and are also needed for rebuilding the
glibc package



%prep
%setup -q -c
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
#%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1

%build

%install
mkdir -p $RPM_BUILD_ROOT
tar -cf -  usr | tar -xf - -C $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/include/asm
pushd $RPM_BUILD_ROOT/usr/include
d1=asm-%{_arch}
d2=asm
%ifarch x86_64
p1='defined __x86_64__'
d2=asm-i386
p2='defined __i386__'
%endif
%ifarch sparc sparc64
d1=asm-sparc
p1='defined __sparc__ && !defined __arch64__'
d2=asm-sparc64
p2='defined __sparc__ && defined __arch64__'
%endif
%ifarch ppc ppc64
d1=asm-ppc
p1='defined __powerpc__ && !defined __powerpc64__'
d2=asm-ppc64
p2='defined __powerpc64__'
%endif
%ifarch s390 s390x
d1=asm-s390
p1='defined __s390__ && !defined __s390x__'
d2=asm-s390x
p2='defined __s390x__'
%endif
for i in asm-*; do
  case $i in $d1|$d2) ;; *) rm -rf $i;; esac
done
if [ "$d2" = "asm" ]; then
  rm -rf asm
  mv $d1 asm
else
  for f in `find $d1 $d2 -name \*.h -exec basename {} \; | sort -u`; do
    F=`echo $f | tr a-z. A-Z_`
    ( cat <<EOF
#ifndef __ASM_STUB_${F}__
# define __ASM_STUB_${F}__
EOF
      echo "# if $p1"
      if [ -f $d1/$f ]; then
	echo "#  include <$d1/$f>"
      else
	echo "#  error <$d1/$f> does not exist"
      fi
      echo "# endif"
      echo "# if $p2"
      if [ -f $d2/$f ]; then
	echo "#  include <$d2/$f>"
      else
	echo "#  error <$d2/$f> does not exist"
      fi
      echo "# endif"
      echo "#endif"
    ) > asm/$f
  done
fi
popd

%clean
rm -rf $RPM_BUILD_ROOT


%pre
[ -L /usr/include/linux ] && rm -f /usr/include/linux || :
[ -L /usr/include/asm ] && rm -f /usr/include/asm || :
%ifarch sparc
[ -L /usr/include/asm-sparc ] && rm -f /usr/include/asm-sparc
[ -L /usr/include/asm-sparc64 ] && rm -f /usr/include/asm-sparc64
%endif
exit 0

%post
exit 0

###
### file lists
###

%files
%defattr(-,root,root)
/usr/include/mtd
/usr/include/linux
/usr/include/asm*


%changelog
* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 3.0-5.2
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 3.0-5.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Mon Feb 6 2006 David Woodhouse <dwmw2@redhat.com> 3.0-5
- Add EOWNERDEAD and ENOTRECOVERABLE error codes

* Tue Jan 24 2006 David Woodhouse <dwmw2@redhat.com> 3.0-4
- Add pselect/ppoll on x86_64

* Fri Jan 20 2006 David Woodhouse <dwmw2@redhat.com> 3.0-3
- Add new syscalls up to 2006-01-20

* Tue Oct 25 2005 David Woodhouse <dwmw2@redhat.com> 3.0-2
- Fix order of version and ihl in struct iphdr. (#171678)

* Mon Jun 13 2005 David Woodhouse <dwmw2@redhat.com> 3.0-1
- Add WDIOC_GETTIMEOUT, WDIOC_SETTIMEOUT to watchdog.h (#155653)
- Update version number to make it not look confusingly like a kernel version

* Mon May 23 2005 David Woodhouse <dwmw2@redhat.com> 2.4-9.1.95
- Update audit.h, add CAP_AUDIT_{WRITE,CONTROL} to capability.h

* Sun Apr 17 2005 David Woodhouse <dwmw2@redhat.com> 2.4-9.1.94
- Remove __user from videodev, dvb headers (#155157)

* Fri Apr 15 2005 David Woodhouse <dwmw2@redhat.com> 2.4-9.1.93
- Restore version.h to 2.4.20. Yeah, stuff which depends on it is broken,
  but let's not rub it in their faces till after FC4 is out.

* Fri Apr 15 2005 David Woodhouse <dwmw2@redhat.com> 2.4-9.1.92
- Fix PT_FPSCR definition on PPC64 (#91727)
- Move PPC_PTRACE_xxx_3264 from ppc64 to ppc32 ptrace.h (#97641)
- Support VMX in ptrace.h on ppc/ppc64 (#146727)
- Fix ppc64 stat.h, statfs.h (#146909, #146914)
- Update ia64 ptrace_offsets.h (#117234)
- Add IPV6_V6ONLY to in6.h (#97088)
- Update cosmetic version in linux/version.h (#117020)
- Include videodev2.h (#122671)
- Drop contents of quota.h. Just bitch and include sys/quota.h instead.
- Fix socket.h definitions to add SO_PEERSEC, AF_LLC, etc. (#134444)
- Add x86_64 mce.h (#137974)
- Provide linux/futex.h (#138823)
- The GPL has more than one term (#139184)
- Fix duplicate definition of __NR_epoll_{ctl,wait} on x86_64 (#139586)
- Include uinput.h (#142812)
- Include if_infiniband.h (#147590)
- Add SHM_EXEC to shm.h (#150602)
- Add DVB headers (#154493)
- Add keyctl.h and new errno values (#154567)
- Add missing waitid and keyctl syscalls to */unistd.h (#154567,#140951)

* Wed Feb 23 2005 David Woodhouse <dwmw2@redhat.com> 2.4.9-1.90
- Add linux/audit.h (#139935)

* Thu Jan 20 2005 David Woodhouse <dwmw2@redhat.com> 2.4-9.1.89
- Revert the tarball update of December 10th; too much was pruned.

* Tue Jan 18 2005 David Woodhouse <dwmw2@redhat.com> 2.4-9.1.88
- Fix and update and include missing ATM headers (#127098)
- Update MTD headers.

* Fri Dec 10 2004 Roland McGrath <roland@redhat.com>
- update syscall numbers on x86_64, ia64
- removed many files users should not need
- update ia64 ptrace_offsets.h (#117234)
- other misc updates from upstream

* Tue Aug 31 2004 Arjan van de Ven <arjanv@redhat.com> 2.4-9.1.87
- update input.h

* Thu Jul 29 2004 Arjan van de Ven <arjanv@redhat.com>
- update limits.h to reflect NR_GROUPS change

* Thu Jul 22 2004 Jakub Jelinek <jakub@redhat.com>
- update syscall numbers from latest kernel on alpha/ia64

* Fri Jun 25 2004 Arjan van de Ven <arjanv@redhat.com>
- fix mtrr header for x86_64

* Wed Apr 21 2004 Jakub Jelinek <jakub@redhat.com> 2.4-8.46
- ppc/ppc64 mq_* syscall numbers

* Fri Apr 16 2004 Jakub Jelinek <jakub@redhat.com> 2.4-8.45
- update syscall numbers from latest kernel
- remove ia32.h and ia32_unistd.h on x86-64

* Mon Mar 15 2004 Bill Nottingham <notting@redhat.com> 2.4-8.44
- update wireless.h

* Tue Dec 09 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.38
- remove a lot of kernel-only crud

* Tue Dec  2 2003 Jeremy Katz <katzj@redhat.com> 2.4-8.37
- add BLKGETSIZE64

* Wed Oct 22 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.35
- fix broken shift_hz
* Wed Sep 24 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.34
- fix ppc64 sigcontext.h (#104915)

* Mon Sep  8 2003 Bill Nottingham <notting@redhat.com>
- oops, bring arp_tables.h back

* Wed Sep  3 2003 Bill Nottingham <notting@redhat.com>
- remove some exports of __constant_hton*

* Sat Aug 23 2003 Arjan van de Ven <arjanv@redhat.com>
- fix typo in netdevice.h as per #102951

* Thu Aug 21 2003 Arjan van de Ven <arjanv@redhat.com>
- update personality.h for the amd64 3Gb 32 bit personality

* Tue Aug 19 2003 Arjan van de Ven <arjanv@redhat.com>
- add asm/types.h to a few .h files that need it
- remove unistd.h from linux/limits.h; it breaks samba builds

* Tue Aug 19 2003 Doug Ledford <dledford@redhat.com>
- Add updated prctl.h file that includes process timing defines

* Sat Aug 16 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.27
- add tgkill to unistd.h on ppc64, x86_64 and alpha

* Thu Jul 31 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.26
- update ia64/sigcontext.h from 2.5.73+ (#101344)

* Wed Jul 30 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.25
- make ppc64/uaccess.h match the upstream ABI

* Mon Jul 28 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.24
- rebuilt

* Mon Jul 28 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.23
- add tgkill to unistd.h on i386, ia64 and ppc32
- remove __KERNEL_SYSCALLS__ cruft on ia64/ppc32

* Mon Jul 14 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.22
- add arptables headers

* Fri Jun 27 2003 Arjan van de Ven <arjanv@redhat.com> 2.4.8.20
- update ptrace headers for amd64

* Wed Jun 18 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.19
- update for new bonding interface

* Fri Jun 06 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.18
- change syscall stubs to use the glibc ones

* Thu Jun  5 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.17
- rebuilt

* Mon Jun  2 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.16
- add new scsi majors to <linux/major.h> (#91696)

* Fri May 30 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.15
- add amd64 nptl syscalls

* Tue May 27 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.14
- unifdef'd a bunch of header files for __KERNEL__

* Sun Apr 13 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.13
- remove more kernel private files

* Fri Apr 11 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.12
- update <linux/prctl.h> header
- remove i386 <asm/io.h>, replace it with a warning and <sys/io.h> include
  (Arjan van de Ven)

* Mon Feb 10 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.11
- update syscall numbers for all arches from 2.5.64 headers

* Fri Feb  7 2003 Bill Nottingham <notting@redhat.com> 2.4-8.10
- update more wireless headers

* Wed Feb  5 2003 Bill Nottingham <notting@redhat.com> 2.4-8.9
- update wireless headers

* Thu Jan 30 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.7
- make /usr/include/asm during build if it doesn't exist

* Thu Jan 30 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.6
- remove unpackaged file

* Thu Jan 30 2003 Bill Nottingham <notting@redhat.com>
- update netfilter headers

* Thu Jan 30 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.5
- don't include <linux/types.h> etc. in <asm-s390*/ptrace.h>

* Thu Jan 16 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.4
- updated s390 headers, added s390x headers
- HTB in <linux/pkt_sched.h>
- no -debuginfo subpackage

* Thu Dec 12 2002 Jakub Jelinek <jakub@redhat.com> 2.4-8.3
- update version.h from kernel-2.4.20-0.pp.6

* Tue Nov 26 2002 Jakub Jelinek <jakub@redhat.com> 2.4-8.2
- update unistd.h from kernel-2.4.19-0.pp.19

* Thu Oct 10 2002 Jakub Jelinek <jakub@redhat.com>
- generate stubs automatically
- remove /usr/include/scsi from file list

* Thu Oct 10 2002 Arjan van de Ven <arjanv@redhat.com
- added support for mixed 32/64 headers

* Tue Mar 21 2002 Arjan van de Ven <arjanv@redhat.com
- update ethtool and other network ioctls

* Tue Feb 10 2002 Arjan van de Ven <arjanv@redhat.com
- removed autoconf.h content

* Sun Feb 10 2002 Arjan van de Ven <arjanv@redhat.com
- fix missing include that broke quota.h

* Mon Jan 07 2002 Arjan van de Ven <arjanv@redhat.com
- fix rhconfig.h include file to not care about /boot/kernel.h

* Wed Jan 02 2002 Florian La Roche <Florian.LaRoche@redhat.de>
- fix #warning in <asm-i386/rwlock.h> and <asm-i386/spinlock.h>

* Thu Dec 6 2001 Arjan van de Ven <arjanv@redhat.com>
- fix misplaced #endif

* Tue Dec 4 2001 Arjan van de Ven <arjanv@redhat.com>
- fix version.h to not include /boot/kernel.h

* Wed Oct 31 2001 Arjan van de Ven <arjanv@redhat.com>
- Initial packaging
